<?php 
/**
 * @version 1.0
 * @copyright Copyright (C) 2014 rayzzz.com. All rights reserved.
 * @license GNU/GPL2, see LICENSE.txt
 * @website http://rayzzz.com
 * @twitter @rayzzzcom
 * @email rayzexpert@gmail.com
 */
class rz_module extends rz_integration
{
	var $sModule = "rzlivecam";
	var $CHANNELS_DB_TABLE;
	
    function rz_module($sPath, $sUrl)
    {
		parent::__construct($sPath, $sUrl);
		$this->CHANNELS_DB_TABLE = $this->DB_PREFIX . $this->sModule . "_channels";
		
		$this->aXmlTemplates["user"] = array (
			6 => '<user nick="#1#" sex="#2#" age="#3#" photo="#4#" profile="#5#" id="#6#" />'
		);
		$this->aXmlTemplates["channel"] = array (
			10 => '<channel id="#1#" user="#2#" nick="#3#" photo="#4#" screenshot="#5#" edit="#7#" profile="#8#" connect="#9#" count="#10#"><![CDATA[#6#]]></channel>'
		);
    }
	
	function actionConfig(){
        $sContents = parent::actionConfig();

        $sMenuLocation = empty($_COOKIE["RayzLivecamMenu"]) ? "bottom" : $_COOKIE["RayzLivecamMenu"];
        $sContents = str_replace("#menuLocation#", $sMenuLocation, $sContents);
        $sMenuHide = empty($_COOKIE["RayzLivecamMenuHide"]) ? FALSE_VAL : $_COOKIE["RayzLivecamMenuHide"];
        $sContents = str_replace("#menuHide#", $sMenuHide, $sContents);
        $sAutoSound = empty($_COOKIE["RayzLivecamAutoSound"]) ? TRUE_VAL : $_COOKIE["RayzLivecamAutoSound"];
        $sContents = str_replace("#autoSound#", $sAutoSound, $sContents);
        $sChatCalling = empty($_COOKIE["RayzLivecamChatCalling"]) ? TRUE_VAL : $_COOKIE["RayzLivecamChatCalling"];
        $sContents = str_replace("#chatCalling#", $sChatCalling, $sContents);

		return $sContents;
	}
		
	function actionSetConfig(){
		$sKey = $this->_getRequestVar("key");
		$sValue = $this->_getRequestVar("value");
        if(!empty($sKey) && !empty($sValue))
			setCookie("RayzLivecam" . $sKey, $sValue, time() + 31536000);
	}

    function actionUserAuthorize(){
		$sPassword = $this->_getRequestVar("password");
		$aUser = $this->_getUserInfo($this->sId);
        if($this->_loginUser($this->sId, $sPassword))
		{
			$iDelTime = $this->_getDeleteTime();
			$rRes = $this->oDb->getResult("SELECT * FROM `" . $this->CHANNELS_DB_TABLE . "` WHERE `Time`<" . $iDelTime . " OR `User`='" . $this->sId . "'");
			while($aChannel = mysql_fetch_assoc($rRes))
				@unlink($this->sFilesPath . $aChannel['ID'] . ".jpg");
			$this->oDb->getResult("DELETE FROM `" . $this->CHANNELS_DB_TABLE . "` WHERE `Time`<" . $iDelTime . " OR `User`='" . $this->sId . "'");
		}
		else
			$this->sId = time();
			
		$sContents = $this->_parseXml($this->aXmlTemplates['result'], "", $this->SUCCESS_VAL);
		$sContents .= $this->_parseXml($this->aXmlTemplates['user'], $aUser['nick'], $aUser['sex'], $aUser['age'], $aUser['photo'], $aUser['profile'], $this->sId);
		return $sContents;
    }
	
	function actionAdminAuthorize(){
		$sPassword = $this->_getRequestVar("password");
		if($this->_loginUser($this->sId, $sPassword))
			return $this->actionUserAuthorize();
		else
			return $this->_parseXml($this->aXmlTemplates['result'], "msgAuthorizingError", $this->FAILED_VAL);
    }
	
	function actionDelete(){
		$sConnect = $this->_getRequestVar("connect");
        $this->oDb->getResult("DELETE FROM `" . $this->CHANNELS_DB_TABLE . "` WHERE `Connect`=" . $sConnect . " LIMIT 1");
    }
	
	function actionGetChannels(){
		$sContents = "";
        $rRes = $this->oDb->getResult("SELECT * FROM `" . $this->CHANNELS_DB_TABLE . "` WHERE `Time`>" . $this->_getDeleteTime());
		while($aChannel = mysql_fetch_assoc($rRes))
		{
			$aUser = $this->_getUserInfo($aChannel['User']);
			$sContents .= $this->_parseXml($this->aXmlTemplates['channel'], $aChannel['ID'], $aChannel['User'], $aUser['nick'], $aUser['photo'], $aChannel['ID'] . ".jpg", $aChannel['Title'], ($aChannel['Edit'] ? $this->TRUE_VAL : $this->FALSE_VAL), $aUser['profile'], $aChannel['Connect'], $aChannel['Count']);
		}
		return $this->_makeGroup($sContents, "channels");
    }
	
	function actionNewChannel(){
		$iEdit = $this->_getRequestVar("edit", "int");
		$sTitle = $this->_getRequestVar("title");
		$sConnect = $this->_getRequestVar("connect");
        
        $this->oDb->getResult("INSERT INTO `" . $this->CHANNELS_DB_TABLE . "`(`User`,`Title`,`Edit`,`Connect`,`Time`) VALUES('" . $this->sId . "','" . $sTitle . "'," . $iEdit . ", '" . $sConnect . "', " . time() . ")");
		$iId = $this->oDb->getLastInsertId();
		if($iId > 0)
			return $this->_parseXml($this->aXmlTemplates['result'], $iId, $this->SUCCESS_VAL);
		else
			return $this->_parseXml($this->aXmlTemplates['result'], "", $this->FAILED_VAL);
    }
	
	function actionSetCount(){
		$iCount = $this->_getRequestVar("count", "int");
		$this->oDb->getResult("UPDATE `" . $this->CHANNELS_DB_TABLE . "` SET `Count`=" . $iCount . " WHERE `ID`='" . $this->sId . "'");
	}
		
	function actionTransmit(){
		$this->oDb->getResult("UPDATE `" . $this->CHANNELS_DB_TABLE . "` SET `Time`=" . time() . " WHERE `ID`='" . $this->sId . "'");
        if(!function_exists("imagecreatetruecolor"))
            return $this->_parseXml($this->aXmlTemplates['result'], 'msgErrorGD', $this->FAILED_VAL);

		$iWidth = $this->_getRequestVar("width", "int");
		$iHeight = $this->_getRequestVar("height", "int");
		$iBackColor = $this->_getRequestVar("backColor", "int");
		if(empty($iBackColor))
			$iBackColor = 16777216;
		$sData = $this->_getRequestVar("data");
        $iQuality = 100;

        $aData = explode(',', $sData);
        $aImageData = array();
        for($i=0; $i<count($aData); $i++)
            $aImageData[$i] = base_convert($aData[$i], 36, 10);

        //--- Create Image Resource ---//
        $rImage = @imagecreatetruecolor($iWidth, $iHeight);
        for($i=0, $y=0; $y<$iHeight; $y++)
            for($x=0; $x<$iWidth; $x++, $i++)
                @imagesetpixel($rImage, $x, $y, isset($aImageData[$i]) ? $aImageData[$i] : $iBackColor);

        //--- Save image file ---//
        $sFileName = $this->sFilesPath . $this->sId . ".jpg";
        $bFileCreated = @imagejpeg($rImage, $sFileName, $iQuality);
        if($bFileCreated)
			return $this->_parseXml($this->aXmlTemplates['result'], "", $this->SUCCESS_VAL);
		else
			return $this->_parseXml($this->aXmlTemplates['result'], "msgErrorFile", $this->FAILED_VAL);
	}
	
	function _getDeleteTime()
	{
		return time() - 180*(int)$this->_getSettingValue("updateInterval");
	}
}
